{Aussehen wie ein Bildschirmschoner:
   Stichworte: form1.WindowState:=wsmaximized;
               form1.borderstyle:=bsNone; //Im Gegensatz zu bsSizeable
               Instanzen werden dynamische erzeugt (Create/Free)
               Dynamischer Array (setlength)
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const AnzahlKreise=20;
var
  Form1: TForm1;


implementation

uses unit2;              // Einbinden der TKreis-Unit

{$R *.DFM}

var Kreis: array of TKreis;      //Objekte deklarieren

function ZufallsFarbe:integer;
begin result:=random(256)+256*random(256)+256*256*random(256) end;

procedure NeuerKreis;
  var k:integer;
begin
 k:=length(kreis);
 setlength(kreis,k+1);
 Kreis[k] := TKreis.Create(random(Form1.Width),random(Form1.Height),
             random(11)-5,Random(11)-5,zufallsfarbe);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
 showmessage('Beenden:Mausklick');
 randomize;
 Canvas.Brush.Style := bssolid;
 while length(kreis)<AnzahlKreise do NeuerKreis;
end;

procedure anzeigen(Kreis:TKreis);    // Anzeigeroutine fr ein TKreis-Objekt
 begin
   Kreis.Zeichnen(Form1.Canvas, Form1.Color); // alte Position mit Hintergrundfarbe lschen
   Kreis.x := Kreis.x + Kreis.vx;             // Verschieben der x-Position
   Kreis.y := Kreis.y + Kreis.vy;
   If Kreis.x >= Form1.ClientWidth then Kreis.vx:=-Kreis.vx; // rckwrts
   if Kreis.x<=0 then Kreis.vx:=-Kreis.vx;                   //wieder vorwrts
   If Kreis.y >= Form1.ClientHeight then Kreis.vy:=-Kreis.vy; // aufwrts
   if Kreis.y<=0 then Kreis.vy:=-Kreis.vy;                   //wieder runter
   Kreis.Zeichnen(Form1.Canvas, Kreis.farbe)      // an neuer Position zeichnen
 end;

procedure TForm1.Timer1Timer(Sender: TObject);  // periodisches Anzeigen
  var k:integer;
begin
 for k:=0 to length(kreis)-1 do Begin
   anzeigen(Kreis[k]);
   kreis[k].Geschwindigkeitaendern(-1+random(3),-1+random(3));  //in [-1;1] da 0<=random(3)<=2
 End;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
  var k:integer;
begin
  for k:=0 to length(kreis)-1 do Kreis[k].Free;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if MessageDlg('Jetzt beenden?',
                 mtConfirmation, [mbYes, mbNo], 0) = mrYes
    then close;
  color:=ZufallsFarbe;
  canvas.brush.color:=color;
  Canvas.Rectangle(0,0,width,height);
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  if form1.top=0 then exit;
  WindowState:=wsmaximized;
  borderstyle:=bsNone; //bsSizeable
  Timer1Timer(Nil); //Zeichne zum 1. Mal
end;

end.
